from src.models.abstract_reference import abstract_reference
from src.settings.settings import settings
from src.validation.validator import validator

class company_model (abstract_reference):
    # ИНН
    __tax_id = 0
    # БИК
    __bank_id = 0
    # Счет
    __bank_account_id = 0
    # Форма собственности
    __property_type = ""

    __vtor = validator()


    def __init__(self, name, data: settings):
        """
        Args:
            data (settings): Объект настроек с данными организации
        """
        self.__vtor.check_type(data, settings)
        
        self.__tax_id = data.tax_id
        self.__bank_id = data.bank_id
        self.__bank_account_id = data.bank_account_id
        self.__property_type = data.property_type

        super().__init__(name)

    @property
    def tax_id(self):
        """ИНН"""

        return self.__tax_id
    
    @property
    def bank_id(self):
        """БИК"""

        return self.__bank_id
    
    @property
    def bank_account_id(self):
        """Банковский счет"""

        return self.__bank_account_id
    
    @property
    def property_type(self):
        """Вид собственности"""

        return self.__property_type